"""
Carlos J Corrada Bravo
Este programa calcula el promedio de tiempo de ejecucion de cuatro algoritmos de ordenamiento
La variable maxValor define el valor maximo de los elementos de la lista
La variable largoLista define el largo de las listas a ordenar
La variable veces define las veces que se va a hacer el ordenamiento 
Al final se imprimen los promedios de cada algortimo
"""
from random import randint
import time
from copy import deepcopy

def mergeSort(lista):
	#definan el algoritmo de ordenamiento mergesort
	return lista

def heapSort(lista):
	#definan el algoritmo de ordenamiento heapsort
	return lista

def quickSort(lista):
	#definan el algoritmo de ordenamiento quicksort
	return lista

# inplace
# complexity: O(N^2)
def shellSort(lst):
    # initial gap
    gap = len(lst)

    while 0 < gap:
        # sort every sublist with given gap
        for start in range(gap):
            f = range(start, len(lst), gap)
            s = range(start + gap, len(lst), gap)

            # bubble sort on sublist
            swapped = True
            while swapped:
                swapped = False

                # iterate through every adjacent pair in sublist
                for c, n in zip(f, s):
                    if lst[n] < lst[c]:
                        lst[c], lst[n] = lst[n], lst[c]
                        swapped = True

        # reduce gap towards 0
        gap = gap // 2

    return lst

# timeCode function/thunk -> (duration, return value)
# measures the time it takes for a function/thunk to return
def timeCode(fn):
	t1 = time.perf_counter()
	res = fn()
	duration = time.perf_counter() - t1
	return (duration, res)

maxValor = 1000 	#define el valor maximo de los elementos de la lista
largoLista = 1000 #define el largo de las listas a ordenar
veces = 100 		#define las veces que se va a hacer el ordenamiento

acumulaMerge = 0 	#variable para acumular el tiempo de ejecucion del mergesort
acumulaHeap = 0 	#variable para acumular el tiempo de ejecucion del heapsort
acumulaQuick = 0 	#variable para acumular el tiempo de ejecucion del quicksort
acumulaShell = 0 	#variable para acumular el tiempo de ejecucion del shellsort

for i in range(veces):
	mergelista = [randint(0,maxValor) for r in range(largoLista)] #creamos una lista con valores al azar
	heaplista = deepcopy(mergelista)
	quicklista = deepcopy(mergelista)
	searchlista = deepcopy(mergelista)

	acumulaMerge += timeCode(lambda: mergeSort(mergelista))[0]
	acumulaHeap += timeCode(lambda: heapSort(heaplista))[0]
	acumulaQuick += timeCode(lambda: quickSort(quicklista))[0]
	acumulaShell += timeCode(lambda: shellSort(searchlista))[0]

#imprimos los resultados
print(f"Promedio de tiempo de ejecucion de {str(veces)} listas de largo {str(largoLista)}")
print(f"MergeSort {str(acumulaMerge / veces)} segundos")
print(f"HeapSort {str(acumulaHeap / veces)} segundos")
print(f"QuickSort {str(acumulaQuick / veces)} segundos")
print(f"ShellSort {str(acumulaShell / veces)} segundos")
